/* arch/arm/mach-s3c2410/include/mach/regs-gpiol.h
 *
 * Copyright (c) 2004 Simtec Electronics <linux@simtec.co.uk>
 *		      http://www.simtec.co.uk/products/SWLINUX/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * S3C2443 GPIO L register definitions
*/


#ifndef __ASM_ARCH_REGS_GPIOL_H
#define __ASM_ARCH_REGS_GPIOL_H "gpiol"

#define S3C2443_GPIO_BANKL  (32*15)

#define S3C2443_GPLCON      S3C2410_GPIOREG(0xf0)
#define S3C2443_GPLDAT      S3C2410_GPIOREG(0xf4)
#define S3C2443_GPLUDP      S3C2410_GPIOREG(0xf8)

#define S3C2443_GPL0            S3C2410_GPIONO(S3C2443_GPIO_BANKL, 0)
#define S3C3443_GPL0_INP        (0x00 << 0)
#define S3C2443_GPL0_OUTP       (0x01 << 0)
#define S3C2443_GPL0_SD0DAT0    (0x02 << 0)
#define S3C2450_GPL0_SD1DAT0    (0x02 << 0)

#define S3C2443_GPL1            S3C2410_GPIONO(S3C2443_GPIO_BANKL, 1)
#define S3C2443_GPL1_INP        (0x00 << 2)
#define S3C2443_GPL1_OUTP       (0x01 << 2)
#define S3C2443_GPL1_SD0DAT1    (0x02 << 2)
#define S3C2450_GPL1_SD1DAT1    (0x02 << 2)

#define S3C2443_GPL2            S3C2410_GPIONO(S3C2443_GPIO_BANKL, 2)
#define S3C2443_GPL2_INP        (0x00 << 4)
#define S3C2443_GPL2_OUTP       (0x01 << 4)
#define S3C2443_GPL2_SD0DAT2    (0x02 << 4)
#define S3C2450_GPL2_SD1DAT2    (0x02 << 4)

#define S3C2443_GPL3            S3C2410_GPIONO(S3C2443_GPIO_BANKL, 3)
#define S3C2443_GPL3_INP        (0x00 << 6)
#define S3C2443_GPL3_OUTP       (0x01 << 6)
#define S3C2443_GPL3_SD0DAT3    (0x02 << 6)
#define S3C2450_GPL3_SD1DAT3    (0x02 << 6)

#define S3C2443_GPL4            S3C2410_GPIONO(S3C2443_GPIO_BANKL, 4)
#define S3C2443_GPL4_INP        (0x00 << 8)
#define S3C2443_GPL4_OUTP       (0x01 << 8)
#define S3C2443_GPL4_SD0DAT4    (0x02 << 8)
#define S3C2450_GPL4_SD1DAT4    (0x02 << 8)

#define S3C2443_GPL5            S3C2410_GPIONO(S3C2443_GPIO_BANKL, 5)
#define S3C2443_GPL5_INP        (0x00 << 10)
#define S3C2443_GPL5_OUTP       (0x01 << 10)
#define S3C2443_GPL5_SD0DAT5    (0x02 << 10)
#define S3C2450_GPL5_SD1DAT5    (0x02 << 10)

#define S3C2443_GPL6            S3C2410_GPIONO(S3C2443_GPIO_BANKL, 6)
#define S3C2443_GPL6_INP        (0x00 << 12)
#define S3C2443_GPL6_OUTP       (0x01 << 12)
#define S3C2443_GPL6_SD0DAT6    (0x02 << 12)
#define S3C2450_GPL6_SD1DAT6    (0x02 << 12)

#define S3C2443_GPL7            S3C2410_GPIONO(S3C2443_GPIO_BANKL, 7)
#define S3C2443_GPL7_INP        (0x00 << 14)
#define S3C2443_GPL7_OUTP       (0x01 << 14)
#define S3C2443_GPL7_SD0DAT7    (0x02 << 14)
#define S3C2450_GPL7_SD1DAT7    (0x02 << 14)

#define S3C2443_GPL8            S3C2410_GPIONO(S3C2443_GPIO_BANKL, 8)
#define S3C2443_GPL8_INP        (0x00 << 16)
#define S3C2443_GPL8_OUTP       (0x01 << 16)
#define S3C2443_GPL8_SD0CMD     (0x02 << 16)
#define S3C2450_GPL8_SD1CMD     (0x02 << 16)

#define S3C2443_GPL9            S3C2410_GPIONO(S3C2443_GPIO_BANKL, 9)
#define S3C2443_GPL9_INP        (0x00 << 18)
#define S3C2443_GPL9_OUTP       (0x01 << 18)
#define S3C2443_GPL9_SD0CLK     (0x02 << 18)
#define S3C2450_GPL9_SD1CLK     (0x02 << 18)

#define S3C2443_GPL10           S3C2410_GPIONO(S3C2443_GPIO_BANKL, 10)
#define S3C2443_GPL10_INP       (0x00 << 20)
#define S3C2443_GPL10_OUTP      (0x01 << 20)
#define S3C2443_GPL10_SPICLK1   (0x02 << 20)

#define S3C2443_GPL11           S3C2410_GPIONO(S3C2443_GPIO_BANKL, 11)
#define S3C2443_GPL11_INP       (0x00 << 22)
#define S3C2443_GPL11_OUTP      (0x01 << 22)
#define S3C2443_GPL11_SPIMOSI1  (0x02 << 22)

#define S3C2443_GPL12           S3C2410_GPIONO(S3C2443_GPIO_BANKL, 12)
#define S3C2443_GPL12_INP       (0x00 << 24)
#define S3C2443_GPL12_OUTP      (0x01 << 24)
#define S3C2443_GPL12_SPIMISO1  (0x02 << 24)

#define S3C2443_GPL13           S3C2410_GPIONO(S3C2443_GPIO_BANKL, 13)
#define S3C2443_GPL13_INP       (00x0 << 26)
#define S3C2443_GPL13_OUTP      (0x01 << 26)
#define S3C2443_GPL13_nSS0      (0x02 << 26)

#define S3C2443_GPL14           S3C2410_GPIONO(S3C2443_GPIO_BANKL, 14)
#define S3C2443_GPL14_INP       (0x00 << 28)
#define S3C2443_GPL14_OUTP      (0x01 << 28)
#define S3C2443_GPL14_nSS1      (0x02 << 28)

#endif	/* __ASM_ARCH_REGS_GPIOL_H */
