/* linux/arch/arm/plat-s3c/dev-g2d.c
 *
 * Copyright 2008 Simtec Electronics
 *	Ben Dooks <ben@simtec.co.uk>
 *	http://armlinux.simtec.co.uk/
 *
 * S3C series device definition for framebuffer device
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
*/

#include <linux/kernel.h>
#include <linux/string.h>
#include <linux/platform_device.h>

#include <mach/irqs.h>
#include <mach/map.h>

#include <plat/devs.h>
#include <plat/cpu.h>

static struct resource s3c_g2d_resource[] = {
	[0] = {
		.start = S3C_PA_G2D,
		.end   = S3C_PA_G2D + SZ_4K - 1,
		.flags = IORESOURCE_MEM,
	},
	[1] = {
		.start = IRQ_G2D,
		.end   = IRQ_G2D,
		.flags = IORESOURCE_IRQ,
	},
};

struct platform_device s3c_device_g2d = {
	.name		  = "s3c-g2d",
	.id		  = -1,
	.num_resources	  = ARRAY_SIZE(s3c_g2d_resource),
	.resource	  = s3c_g2d_resource,
	.dev.dma_mask	  = &s3c_device_g2d.dev.coherent_dma_mask,
	.dev.coherent_dma_mask = 0xffffffffUL,
};
