#ifndef __ASM_ARCH_REGS_G2D_H
#define __ASM_ARCH_REGS_G2D_H __FILE__

/*
 * General Registers
 */
#define S3C_G2D_CONTROL_REG		(0x0000)
#define S3C_G2D_INTEN_REG		(0X0004)
#define S3C_G2D_INTEN_CCF		(1<<10)
#define S3C_G2D_INTEN_ACF		(1<<9)
#define S3C_G2D_INTEN_FIFO_FULL		(1<<8)
#define S3C_G2D_INTEN_FIFO_INT_E	(1<<0)
#define S3C_G2D_FIFO_INTC_REG		(0x0008)
#define S3C_G2D_INTC_PEND_REG		(0x000C)
#define S3C_G2D_INTP_CMD_FIN		(1<<10)
#define S3C_G2D_INTP_ALL_FIN		(1<<9)
#define S3C_G2D_INTP_FULL		(1<<8)
#define S3C_G2D_INTP_FIFO_LEVEL		(1<<0)
#define S3C_G2D_FIFO_STAT_REG		(0x0010)
#define S3C_G2D_FIFO_STAT_CMD_FIN	(1<<10)
#define S3C_G2D_FIFO_STAT_ALL_FIN	(1<<9)
#define S3C_G2D_FIFO_STAT_IDLE		(S3C_G2D_FIFO_STAT_CMD_FIN|S3C_G2D_FIFO_STAT_ALL_FIN)
#define S3C_G2D_FIFO_USED(_x)		(((_x)>>1) & 0x3F)

/*
 * Command Registers
 */ 
#define S3C_G2D_CMD0_REG		(0x0100)
#define S3C_G2D_CMD1_REG		(0x0104)
#define S3C_G2D_CMD1_BITBLT_NO		(0)
#define S3C_G2D_CMD1_BITBLT_NORMAL	(1)
#define S3C_G2D_CMD1_BITBLT_STRETCH	(2)
#define S3C_G2D_CMD2_REG		(0x0108)
#define S3C_G2D_CMD3_REG		(0x010C)
#define S3C_G2D_CMD4_REG		(0x0110)
#define S3C_G2D_CMD5_REG		(0x0114)
#define S3C_G2D_CMD6_REG		(0x0118)
#define S3C_G2D_CMD7_REG		(0x011C)

/*
 * Parameter Setting Registers
 */
/* Resolution */
#define S3C_G2D_SRC_RES_REG		(0x0200)
#define S3C_G2D_SRC_HORI_RES_REG	(0x0204)
#define S3C_G2D_SRC_VERT_RES_REG	(0x0208)
#define S3C_G2D_SC_RES_REG		(0x0210)
#define S3C_G2D_SC_HORI_RES_REG		(0x0214)
#define S3C_G2D_SC_VERT_RES_REG		(0x0218)

#define S3C_G2D_FULL_V(_x) (((_x)&0x7FF) << 16)
#define S3C_G2D_FULL_H(_x) (((_x)&0x7FF) << 0)

/* Clipping Window */
#define S3C_G2D_CW_LT_REG		(0x0220)
#define S3C_G2D_CW_LT_X_REG		(0x0224)
#define S3C_G2D_CW_LT_Y_REG		(0x0228)
#define S3C_G2D_CW_RB_REG		(0x0230)
#define S3C_G2D_CW_RB_X_REG		(0x0234)
#define S3C_G2D_CW_RB_Y_REG		(0x0238)

/* Coordinates */
#define S3C_G2D_COORD0_REG		(0x0300)
#define S3C_G2D_COORD0_X_REG		(0x0304)
#define S3C_G2D_COORD0_Y_REG		(0x0308)
#define S3C_G2D_COORD1_REG		(0x0310)
#define S3C_G2D_COORD1_X_REG		(0x0314)
#define S3C_G2D_COORD1_Y_REG		(0x0318)
#define S3C_G2D_COORD2_REG		(0x0320)
#define S3C_G2D_COORD2_X_REG		(0x0324)
#define S3C_G2D_COORD2_Y_REG		(0x0328)
#define S3C_G2D_COORD3_REG		(0x0330)
#define S3C_G2D_COORD3_X_REG		(0x0334)
#define S3C_G2D_COORD3_Y_REG		(0x0338)

/* Rotation */
#define S3C_G2D_ROT_OC_REG		(0x0340)
#define S3C_G2D_ROT_OC_X_REG		(0x0344)
#define S3C_G2D_ROT_OC_Y_REG		(0x0348)
#define S3C_G2D_ROTATE_REG		(0x034C)
#if 0
#define S3C_G2D_ROTATE_0		(1 << 0)
#define S3C_G2D_ROTATE_90		(1 << 1)
#define S3C_G2D_ROTATE_180		(1 << 2)
#define S3C_G2D_ROTATE_270		(1 << 3)
#define S3C_G2D_ROTATE_X_FLIP		(1 << 4)
#define S3C_G2D_ROTATE_Y_FLIP		(1 << 5)
#endif

/* X,Y Increment Setting */
#define S3C_G2D_X_INCR_REG		(0x0400)
#define S3C_G2D_Y_INCR_REG		(0x0404)

/* ROP & Alpha Setting */
#define S3C_G2D_ROP_REG			(0x0410)
#if 0
#define S3C_G2D_ROP_OS_PATTERN		(1 << 13)
#define S3C_G2D_ROP_OS_FG_COLOR		(0 << 13)
#define S3C_G2D_ROP_ABM_NO_BLENDING	(0 << 10)
#define S3C_G2D_ROP_ABM_PIXEL		(1 << 10)
#define S3C_G2D_ROP_ABM_REGISTER	(2 << 10)
#define S3C_G2D_ROP_ABM_FADING		(4 << 10)
#define S3C_G2D_ROP_T_OPAQUE		(0 << 9)
#define S3C_G2D_ROP_T_TRANSPARENT	(1 << 9)

#define S3C_G2D_ROPV_SOURCE		(0xF0)
#define S3C_G2D_ROPV_DESTINATION	(0xCC)
#define S3C_G2D_ROPV_PATTERN		(0xAA)
#define S3C_G2D_ROP_VALUE(_x)		((_x)&0xFF)
#else
#define S3C_G2D_ROP_OS_SHIFT		(13)
#define S3C_G2D_ROP_OS_MASK		(1 << 13)

#define S3C_G2D_ROP_TRANSPARENT_SHIFT	(9)
#define S3C_G2D_ROP_TRANSPARENT_MASK	(1<<9)

#define S3C_G2D_ROP_ALPHA_MODE_SHIFT	(10)
#define S3C_G2D_ROP_ALPHA_MODE_MASK	(7 << 10)

#define S3C_G2D_ROP_ROP_SHIFT		(0)
#define S3C_G2D_ROP_ROP_MASK		(0xFF)
#endif

#define S3C_G2D_ALPHA_REG		(0x0420)
#if 0
#define S3C_G2D_ALPHA(_x)		((_x)&0xFF)
#else
#define S3C_G2D_ALPHA_ALPHA_SHIFT	0
#define S3C_G2D_ALPHA_ALPHA_MASK	0xFF
#define S3C_G2D_ALPHA_FADING_SHIFT	8
#define S3C_G2D_ALPHA_FADING_MASK	(0xFF << 8)
#endif

/* Color */
#define S3C_G2D_FG_COLOR_REG		(0x0500)
#define S3C_G2D_BG_COLOR_REG		(0x0504)
#define S3C_G2D_BS_COLOR_REG		(0x0508)
#define S3C_G2D_SRC_COLOR_MODE_REG	(0x0510)
#define S3C_G2D_DEST_COLOR_MODE_REG	(0x0514)

#if 0
/* Color Setting */
#define S3C_G2D_COLOR_RGB_565		0
#define S3C_G2D_COLOR_RGBA_5551		1
#define S3C_G2D_COLOR_ARGB_1555		2
#define S3C_G2D_COLOR_RGBA_8888		3
#define S3C_G2D_COLOR_ARGB_8888		4
#define S3C_G2D_COLOR_XRGB_8888		5
#define S3C_G2D_COLOR_RGBX_8888		6
#endif

/* Pattern */
#define S3C_G2D_PATTERN_REG(_x)		(0x0600 + (_x)*4)
#define S3C_G2D_PATOFF_REG		(0x0700)
#define S3C_G2D_PATOFF_X_SHIFT		(0)
#define S3C_G2D_PATOFF_Y_SHIFT		(16)
#define S3C_G2D_PATOFF_X_REG		(0x0704)
#define S3C_G2D_PATOFF_Y_REG		(0x0708)

/* Stencil Test */
#define S3C_G2D_STENCIL_CNTL_REG	(0x0720)
#define S3C_G2D_STENCIL_DR_MIN_REG	(0x0724)
#define S3C_G2D_STENCIL_DR_MAX_REG	(0x0728)

/* Image Base Address */
#define S3C_G2D_SRC_BASE_ADDR_REG	(0x0730)
#define S3C_G2D_DEST_BASE_ADDR_REG	(0x0734)

#endif /* ! __ASM_ARCH_REGS_G2D_H */
