/*
 * alc5621.h  --  ALC5621 Soc Audio driver
 *
 * Copyright 2005 Openedhand Ltd.
 *
 * Author: Richard Purdie <richard@openedhand.com>
 *
 * Based on wm8731.h
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef _ALC5621_H
#define _ALC5621_H

/* ALC5621 register space */
#define ALC5621_RESET	0x00
#define ALC5621_SPKVOL	0x02
#define ALC5621_HPVOL	0x04
#define ALC5621_AOVOL	0x06
#define ALC5621_AIVOL	0x08
#define ALC5621_LIVOL	0x0A
#define ALC5621_DACVOL	0x0C
#define ALC5621_MICVOL	0x0E
#define ALC5621_MICSW	0x10
#define ALC5621_ADCVOL	0x12
#define ALC5621_ADCSW	0x14
#define ALC5621_AVOL	0x16
#define ALC5621_OUTSW	0x1C
#define ALC5621_MICCTL	0x22
#define ALC5621_DAICTL	0x34
#define ALC5621_CLKCTL	0x36
#define ALC5621_COMPCTL	0x38
#define ALC5621_PWR1	0x3A
#define ALC5621_PWR2	0x3C
#define ALC5621_PWR3	0x3E
#define ALC5621_ACTL	0x40
#define ALC5621_GCLKCTL	0x42
#define ALC5621_PLLCTL	0x44
#define ALC5621_GPIOOUT	0x4A
#define ALC5621_GPIOCFG	0x4C
#define ALC5621_GPIOPOL	0x4E
#define ALC5621_GPIOSTK	0x50
#define ALC5621_GPIOWAK	0x52
#define ALC5621_GPIOSTA	0x54
#define ALC5621_GPIOSHA	0x56
#define ALC5621_OVERCUR	0x58
#define ALC5621_JACK	0x5A
#define ALC5621_MISC	0x5E
#define ALC5621_EFFECT	0x60
#define ALC5621_EQCTL	0x62
#define ALC5621_EQMODE	0x66
#define ALC5621_AVC	0x68
#define ALC5621_IDXADR	0x6A
#define ALC5621_IDXDAT	0x6C

#define ALC5621_VENDOR1	0x7C
#define ALC5621_VENDOR2	0x7E

#define ALC5621_IDX_B0COEFF	0x00
#define ALC5621_IDX_B0GAIN	0x01
#define ALC5621_IDX_B1COEFF1	0x02
#define ALC5621_IDX_B1COEFF2	0x03
#define ALC5621_IDX_B1GAIN	0x04
#define ALC5621_IDX_B2COEFF1	0x05
#define ALC5621_IDX_B2COEFF2	0x06
#define ALC5621_IDX_B2GAIN	0x07
#define ALC5621_IDX_B3COEFF1	0x08
#define ALC5621_IDX_B3COEFF2	0x09
#define ALC5621_IDX_B3GAIN	0x0A
#define ALC5621_IDX_B4COEFF	0x0B
#define ALC5621_IDX_B4GAIN	0x0C
#define ALC5621_IDX_EQIVC	0x11
#define ALC5621_IDX_EQOVC	0x12
#define ALC5621_IDX_AVC1	0x21
#define ALC5621_IDX_AVC2	0x22
#define ALC5621_IDX_AVC3	0x23
#define ALC5621_IDX_AVC4	0x24
#define ALC5621_IDX_AVC5	0x25
#define ALC5621_IDX_DIGITAL	0x39
#define ALC5621_IDX_CLASSD	0x46

#define ALC5621_ADDA_CLK_256FS	(0<<1)
#define ALC5621_ADDA_CLK_384FS	(1<<1)
#define ALC5621_ADDA_CLK_MASK	(1<<1)

struct alc5621_setup_data {
	int            i2c_bus;
	unsigned short i2c_address;
};

extern struct snd_soc_dai alc5621_dai;
extern struct snd_soc_codec_device soc_codec_dev_alc5621;

#endif
